SystemOrganization addCategory: #'GT-Debugger'!

!DebugAction methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/27/2013 11:43'!
asGlamourAction

	^ ((GLMGenericAction new) 
			action: [ self execute ]; 
			icon: self icon;
			title: self label;
			category: self category;
			yourself)! !

!ChangeDebuggerAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 7/4/2013 14:56'!
gtChangeDebuggerActionsFor: aDebugger
	<gtContextDebuggingAction>
	
	^ self 
		changeDebuggerActionsForContext: aDebugger currentContext 
		excluding: aDebugger! !

!PreDebugWindow methodsFor: '*gt-debugger' stamp: 'TudorGirba 11/1/2012 21:23'!
spawnGTDebugger
	model spawnGTDebugger! !

!SaveDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/26/2013 23:11'!
gtActionType
	<gtCodeDebuggingAction>! !

!SaveDebugAction methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/18/2013 17:23'!
asGlamourAction

	^ super asGlamourAction
			action: [ :textPresentation | 
				self sourceCode: textPresentation text.
				self execute ]! !

!DebugContext methodsFor: '*gt-debugger' stamp: 'AndreiChis 6/5/2013 14:53'!
gtDebuggerRetrieveVariableValuePairs
	|fieldList|

	fieldList := OrderedCollection new.
	fieldList 
		add: ('_self' ->  context receiver);
	      addAll: (context receiver class allInstVarNames collect: [:each | each -> (context receiver instVarNamed: each) ]).
	
	fieldList add: ('_thisContext' ->  context).
	 context == nil ifTrue: [^fieldList].
	fieldList 
		add: ('_stack top' -> ( context stackPtr > 0 ifTrue: [ context top])).
		
	(context tempNames size > 0) ifTrue: [
		fieldList addAll: ((1 to: context tempNames size) collect: [ :index || key value |
			key := context tempNames at: index.
			value := [context debuggerMap namedTempAt: index in: context] 
				on: Error 
				do: [value := (Text string: 'error obtaining field value' attribute: TextColor red) asString ].
			key -> value ] ) ].
	
	^ fieldList! !

!CreateMessageDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/26/2013 23:14'!
gtActionType
	<gtContextDebuggingAction>! !

!DebugSession class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/26/2013 23:58'!
gtDebuggingActionsForPragma: aSymbol for: aDebugger

	^ (DebugAction allSubclasses 
		select: [ :each | each hasAbstractMethods not ]) 
			inject: OrderedCollection new 
			into: [ :currentActions :aClass |  
				currentActions addAll: (
					self 
						gtDebuggingActionsFromClass: aClass 
						forPragma: aSymbol 
						forDebugger: aDebugger); yourself  ]! !

!DebugSession class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/27/2013 11:39'!
gtDebuggingActionsFromClass: aClass forPragma: aSymbol forDebugger: aDebugger
	| pragmas actions |
	pragmas := Pragma 
				allNamed: aSymbol
				from: aClass class
				to: aClass class.
	
	actions := OrderedCollection new.
	pragmas do: [ :aPragma |
		actions addAll: 
			((aPragma methodClass soleInstance
				perform: aPragma selector withEnoughArguments: {aDebugger}) asOrderedCollection 
					collect: [ :each | each forDebugger: aDebugger ])  ].
		
	^ actions sort: [ :action1 :action2 | action1 order < action2 order ]! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 6/20/2013 15:57'!
recompileMethodTo: aText inContext: aMethodContext notifying: anUndefinedObject 
	^ (self recompileMethodTo: aText inContext: aMethodContext) isNil not! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 7/8/2013 11:40'!
stepUntil: aPredicate
	
	self stepUntil: aPredicate from: self process suspendedContext! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 7/8/2013 11:41'!
stepUntil: aPredicate from: aContext 
	| ctxt |
	
	ctxt := self process stepUntil: aPredicate  from: aContext.
	self  
		updateWithContext: ctxt 
		fromProcess: self process.! !

!InstructionStream methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/29/2013 20:29'!
isInitialnstruction

	^ self pc = self method initialPC! !

!RestartDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/26/2013 23:10'!
gtActionType
	<gtDebuggingAction>! !

!RunToHereDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 7/12/2013 18:38'!
gtActionType
	<gtCodeDebuggingAction>
	
	^ self new
		arguments: [ :action | { action debugger selectionInterval. action currentContext } ].! !

GLMCompositePresentation subclass: #GTDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebugger commentStamp: '<historical>' prior: 0!
GTDebugger is a browser that provides Smalltalk debugging functionality.

An example: 
[ GTDebugger debugProcess: Processor activeProcess.
	Processor activeProcess suspend.
	#(1 2 3 4 5) do: [:each | each asString]
] fork.!

!GTDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 4/2/2013 14:49'!
debugBasedOnSession: aSession

	^ self debugSession: ((self spanNewSessionForContext: aSession context fromProcess: aSession process)
		errorWasInUIProcess: aSession errorWasInUIProcess)! !

!GTDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 1/28/2013 16:39'!
debugContext: aContext fromProcess: aProcess

	^ self debugSession: (self spanNewSessionForContext: aContext fromProcess: aProcess)! !

!GTDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 1/28/2013 16:39'!
debugProcess: aProcess

	^ self debugContext: aProcess suspendedContext fromProcess: aProcess! !

!GTDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 1/28/2013 16:39'!
debugSession: aSession

	<primitive: 19> "simulation guard"

	"WorldState addDeferredUIMessage: ["
		^ self openOn: aSession 
	"]"! !

!GTDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 3/26/2013 15:33'!
defaultTitle
	^ 'Glamorous Debugger'! !

!GTDebugger class methodsFor: 'testing' stamp: 'AndreiChis 3/25/2013 14:42'!
handlesContext: aContext

	^ true! !

!GTDebugger class methodsFor: 'class initialization' stamp: 'AndreiChis 6/19/2013 15:40'!
initialize 

	"Add ourselves to registry. See [Smalltalk tools]" 
	Smalltalk tools registerDebugger: self withRank: 3.! !

!GTDebugger class methodsFor: 'instance creation' stamp: 'TudorGirba 11/25/2012 23:00'!
openOn: anObject 
	^ self new openOn: anObject! !

!GTDebugger class methodsFor: 'private' stamp: 'AndreiChis 1/13/2013 20:19'!
sessionClass

	^ DebugSession ! !

!GTDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 1/15/2013 12:07'!
spanNewSessionForContext: aContext fromProcess: aProcess

	^ self sessionClass process: aProcess context: aContext ! !

!GTDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 1/28/2013 14:33'!
spanNewSessionForProcess: aProcess

	^ self spanNewSessionForContext: aProcess suspendedContext fromProcess: aProcess! !

!GTDebugger methodsFor: 'callbacks' stamp: 'AndreiChis 3/27/2013 11:56'!
actOnBrowserClosing: ann
	self session ifNotNil: [ :aSession | aSession terminate ]! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 7/4/2013 15:08'!
actionsForPragmas: aSymbolsCollection

	^ ((self allActionsForPragmas: aSymbolsCollection) select: [ :aDebugAction | 
			aDebugAction appliesToContextCurrentContext ]) 
				collect: [ :aDebugAction | aDebugAction asGlamourAction ]
! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/26/2013 23:49'!
allActionsForPragmas: aSymbolsCollection
	
	^ aSymbolsCollection 
		inject: OrderedCollection new
		into: [ :currentActions :aSymbol | 
			currentActions 
				addAll: (self session class gtDebuggingActionsForPragma: aSymbol for: self);
				yourself ].


	
! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 6/20/2013 14:37'!
browser 

	^ self presentations first! !

!GTDebugger methodsFor: 'actions' stamp: 'AndreiChis 6/17/2013 16:31'!
close

	self browser close! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:13'!
codeActionsPragmas

	^ { #codeDebuggingAction }! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 6/20/2013 12:03'!
compose
	self title: self debuggerTitle.
	self tabulator with: [:browser | 
		self debuggerStructureIn: browser.
		self debuggerTransmissionsIn: browser ].
	self registerActions.
! !

!GTDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 6/20/2013 14:41'!
currentContext

	^self selectedContext 
		ifNil: [ self interruptedContext ] 
		ifNotNil:  [ self selectedContext  ]! !

!GTDebugger methodsFor: 'actions' stamp: 'AndreiChis 4/1/2013 16:19'!
debug: aContext using: aDebuggerClass
	| currentSession  |
	
	currentSession := self session.
	self detachSession.
	self browser close.
	currentSession updateContextTo: aContext.
	aDebuggerClass debugBasedOnSession: currentSession! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 6/20/2013 12:01'!
debuggerStructureIn: browser
	
	browser
		row: [ :row | 
					row
						column: #stack;
						column: #code ];
		row: #inspector.
		! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 3/26/2013 15:35'!
debuggerTitle
	
	^ self class defaultTitle ! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 7/8/2013 14:10'!
debuggerTransmissionsIn: browser

	browser transmit
		to: #stack;
		andShow: [ :composite | self stackIn: composite ].
	browser transmit
		from: #stack port: #entity;
		to: #stack port: #selection;
		when: [ :session | session notNil ];
		transformed: [:session | session context].
	browser transmit
		from: #stack port: #entity;
		from: #stack port: #selection;
		to: #stack port: #context;
		when: [ :session :context | session notNil ];
		transformed: [ :session :context | session createModelForContext: context ].
	browser transmit
		from: #stack port: #context;
		to: #code;
		andShow: [ :composite | self methodCodeIn: composite ].
	browser transmit
		from: #stack port: #context;
		to: #inspector;
		andShow: [ :composite | self inspectorIn: composite ] 
! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:13'!
debuggingActionsPragmas

	^ { #debuggingAction }! !

!GTDebugger methodsFor: 'actions' stamp: 'AndreiChis 7/4/2013 16:54'!
detachSession
	self flag: 'why silent value?'.
	(self browser pane port: #entity) silentValue: nil! !

!GTDebugger methodsFor: 'intialization' stamp: 'AndreiChis 3/27/2013 11:59'!
errorWasInUIProcess: aBoolean

	self session errorWasInUIProcess: aBoolean! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 7/8/2013 14:10'!
inspectorIn: composite

	composite custom:
			(GTInspector new first "We use the first actual finder because need to send showFirst: to it"
				noTitle;
				noActions;
				showFirst: [ :a | a custom: (GTDebuggerVariablesBrowser new) ];
				yourself)
	! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:22'!
installActionsForRootPragmas: aSymbolsCollection in: aPresentation

	aPresentation dynamicActions: [ :presentation |
		self actionsForPragmas: (aSymbolsCollection collect: [ :aSymbol | #gt, aSymbol capitalized ]) ] .
	
	aPresentation dynamicActionsOnSelection: [ :presentation |
		self actionsForPragmas: (aSymbolsCollection collect: [ :aSymbol | #gtContext, aSymbol capitalized ]) ] .! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:16'!
installCodeActionsFor: aPresentation
	
	self installActionsForRootPragmas: self codeActionsPragmas in: aPresentation! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:14'!
installDebuggingActionsFor: aPresentation

	self installActionsForRootPragmas: self debuggingActionsPragmas in: aPresentation! !

!GTDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 6/19/2013 19:07'!
interruptedContext

	^ self session context! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 7/4/2013 16:35'!
methodCodeIn: composite
	composite smalltalkCode
		doItReceiver: [:contextModel | contextModel receiver ];
		title: 'Source';
		format: #source;
		smalltalkClass: [ :contextModel | contextModel selectedClass ];
		initialize: [ :code | code selectionInterval: (self session selectedCodeRangeForContext: self currentContext) ];
		with: [ :code | self installCodeActionsFor: code ]! !

!GTDebugger methodsFor: 'opening' stamp: 'AndreiChis 7/4/2013 16:53'!
openFullNoSuspendLabel: aString
	"TODO: do not ignore the title"
	
	self open.
	"TODO: why is this necessy here? I took it from the current debugger"
	"errorWasInUIProcess := UIManager default spawnNewProcessIfThisIsUI: interruptedProcess"! !

!GTDebugger methodsFor: 'intialization' stamp: 'AndreiChis 3/27/2013 12:00'!
process: aProcess controller: aController context: aContext

	self session: (self class spanNewSessionForContext: aContext fromProcess: aProcess)! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 7/4/2013 15:36'!
registerActions

	self on: GLMBrowserClosing send: #actOnBrowserClosing: to: self.
	self on: DebugActionExecuted send: #updateBrowser to: self.
! !

!GTDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 6/20/2013 14:37'!
selectedContext

	^ ((self browser paneNamed: #stack) port: #selection) value! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 7/12/2013 18:13'!
selectionInterval

	^ self selectionIntervalForPane: #code! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 7/4/2013 15:37'!
selectionInterval: anInterval

	^ ((self browser paneNamed: #code) port: #selectionInterval) value: anInterval! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 7/12/2013 18:12'!
selectionIntervalForPane: aSymbol

	^ ((self browser paneNamed: aSymbol) port: #selectionInterval) value ifNil: [ ^ 1 to: 0 ]! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 7/4/2013 17:07'!
session
 
	^ (self browser pane port: #entity) value! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 3/27/2013 11:58'!
session: anObject

	^ (self browser pane port: #entity) value: anObject! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 7/4/2013 16:46'!
stackIn: composite
	composite list	
		title: 'Stack';
		"showOnly: 10;"
		display: #stack;
		format: [ :each | String streamContents: [:stream | each printDebugOn: stream ] ];
		with: [ :list | self installDebuggingActionsFor: list ]! !

!GTDebugger methodsFor: 'updating' stamp: 'AndreiChis 7/4/2013 15:35'!
updateBrowser
	| browserPane session |
	
	session := self session.
	browserPane := self browser pane.
	(browserPane port: #entity) silentValue: nil.
	(browserPane port: #entity) value: session.
	browserPane update.! !

!GTDebugger methodsFor: 'updating' stamp: 'AndreiChis 3/27/2013 12:00'!
updateSelectionInterval

	self selectionInterval: (self session pcRangeForContext:  self selectedContext )! !

!GTDebugger methodsFor: 'callbacks' stamp: 'AndreiChis 1/15/2013 15:08'!
windowIsClosing 
	self announce: GLMBrowserClosing new! !

GLMCompositePresentation subclass: #GTDebuggerVariablesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebuggerVariablesBrowser commentStamp: 'TudorGirba 11/2/2012 22:06' prior: 0!
GTDebuggerVariablesBrowser is a special browser that is used in the first pane of the inspector that is embedded in the debugger. Its main intention is to provide a unified list of variables that come from:
- the instance variables of the receiver
- the local variables from the context!

!GTDebuggerVariablesBrowser methodsFor: 'building' stamp: 'TudorGirba 11/25/2012 22:57'!
compose  
	self title: [:each | GTInspector new printObjectAsAnItem: each receiver ].
	self tabulator with: [:browser | 
		browser 
			morphicAct: [:anotherComposite | anotherComposite entity receiver browse]
				icon: GLMUIThemeExtraIcons glamorousBrowse 
				entitled: 'Browse'.
		browser row: #variables; row: #evaluator.
		browser transmit to: #variables; andShow: [:a | 
			self variablesIn: a ].
		browser transmit to: #evaluator; andShow: [:a | 
			self evaluatorIn: a ].
		browser transmit from: #variables; toOutsidePort: #selection.
		browser transmit from: #evaluator; toOutsidePort: #selection ]! !

!GTDebuggerVariablesBrowser methodsFor: 'private building' stamp: 'AndreiChis 10/30/2012 21:03'!
evaluatorIn: composite
	(composite smalltalkCode)
		doItReceiver: #yourself;
		display: [ :model | [model receiver printString asSmalltalkComment, String cr, 'self'] on: Error do: ['"Error printing. Try self printString to debug"'] ];
		selectionPopulate: #selection
			on: $o
			entitled: 'Do it and open (o)'
			with: [ :text :model | Compiler evaluate: text selectedText for: model receiver logged: false ]! !

!GTDebuggerVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 11/2/2012 22:10'!
variablesIn: composite
	composite table
		showOnly: 50;
		display: [ :contextModel | contextModel gtDebuggerRetrieveVariableValuePairs ];
		sorted: [:variablePair1 :variablePair2 | variablePair1 key < variablePair2 key];
		column: 'Variable' evaluated: [:assoc | 
			[ Text fromString: assoc key asString ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
		column: 'Value' evaluated: [:assoc | 
			[ Text fromString: (assoc value printString contractTo: 50) ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
"		icon: [ :each |
			each value class theNonMetaClass browserIcon
				ifNotNil: [ OBMorphicIcons iconNamed: each value class theNonMetaClass browserIcon ] ];"
		send: #value;
		morphicSelectionAct: [:each | each value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse'! !

!StackDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 7/4/2013 12:39'!
gtStackActions
	<gtDebuggingAction>
	
	^ { 
		self new
			label: 'Step Into';
			action: #stepInto:;
			icon: GLMUIThemeExtraIcons glamorousInto;
			order: 20.
			
		self new
			label: 'Step Over';
			action: #stepOver:;
			icon: GLMUIThemeExtraIcons glamorousOver;
			order: 25.
			
		self new
			label: 'Step Through';
			action: #stepThrough:;
			icon: GLMUIThemeExtraIcons glamorousThrough;
			order: 30.
	 }! !

!ResumeDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/26/2013 23:10'!
gtActionType
	<gtDebuggingAction>! !

!WhereIsDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 7/4/2013 11:23'!
gtActionFor: aDebugger
	<gtCodeDebuggingAction>
	
	^ self new
		action: #updateSelectionInterval! !

Debugger subclass: #GTProxyDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTProxyDebugger commentStamp: 'TudorGirba 11/2/2012 22:04' prior: 0!
GTProxyDebugger is a simple extension of the existing debugger that adds a button for "debug glamorously" using the GTDebugger in the regular debugger.

The goal is to provide the possibility of having the GTDebugger next to the classic debugger until the inevitable errors are ironed out.!

!GTProxyDebugger class methodsFor: 'class initialization' stamp: 'AndreiChis 6/20/2013 14:29'!
initialize

	"Add ourselves to registry. See [Smalltalk tools]" 
	Smalltalk tools register: self as: #debugger! !

!GTProxyDebugger methodsFor: 'accessing' stamp: 'AndreiChis 11/25/2012 12:52'!
debuggerClass
	^ GTDebugger ! !

!GTProxyDebugger methodsFor: 'initialize' stamp: 'TudorGirba 11/1/2012 21:23'!
preDebugButtonQuads
	| buttons |
	self isPostMortem 
		ifTrue: [ ^ self postMortemPreDebugButtonQuads ].
	^ {
		{'Proceed' translated.	#proceed. 	#blue. 	'Continue execution' translated}.
		{'Abandon' translated.	#abandon. 	#black.	'Abandon this execution by closing this window' translated}.
		{'Debug'    		translated.		#debug.		#red. 	'Bring up a debugger' translated}.
		{'Debug glamorously' translated. #spawnGTDebugger. #red. 'Bring up the Glamorous Debugger' translated}
	}! !

!GTProxyDebugger methodsFor: 'notifier menu' stamp: 'AndreiChis 1/15/2013 12:14'!
spawnGTDebugger
	| topView |
	topView := self topView.
	topView model: nil.
	"so close won't release me."
	self breakDependents.
	topView delete.
	
	self debuggerClass debugSession: ((self debuggerClass 
		spanNewSessionForContext: self interruptedContext fromProcess: self interruptedProcess)
			errorWasInUIProcess: errorWasInUIProcess) 
! !
GTDebugger initialize!
GTProxyDebugger initialize!
